VoiceServerPrint = LibStub("AceAddon-3.0"):NewAddon("VoiceServerPrint", "AceConsole-3.0")

local options = {
    name = "VoiceServerPrint",
    handler = VoiceServerPrint,
    type = 'group',
    args = {
        IP = {
            type = 'input',
            name = 'Voice Server IP',
            desc = 'The IP Adress of your Voice Server',
            set = 'SetIP',
            get = 'GetIP',
        },
        Port = {
            type = 'input',
            name = 'Voice Server Port',
            desc = 'The Port of your Voice Server',
            set = 'SetPort',
            get = 'GetPort',
        },
        Pw = {
            type = 'input',
            name = 'Voice Server Pw',
            desc = 'The PW of your Voice Server',
            set = 'SetPw',
            get = 'GetPw',
        },
        show = {
            type = 'execute',
            name = 'Self',
            desc = 'Prints your VoiceServer Informations to yourself',
            func = 'showInfo'
        },
        bg = {
            type = 'execute',
            name = 'BG',
            desc = 'Prints your VoiceServer Informations to the bg',
            func = 'showBG'
        },
        group = {
            type = 'execute',
            name = 'Party',
            desc = 'Prints your VoiceServer Informations to the party',
            func = 'showGroup'
        },
        raid = {
            type = 'execute',
            name = 'Raid',
            desc = 'Prints your VoiceServer Informations to the raid',
            func = 'showRaid'
        },
        rw = {
            type = 'execute',
            name = 'RW',
            desc = 'Prints your VoiceServer Informations to the raidwarning (needs promotion)',
            func = 'showRaidWarning'
        },
        gui = {
            type = 'execute',
            name = 'GUI',
            desc = 'Brings up the Grafical User Interface',
            func = 'ToogleGUI'
        },
        short = {
            type = 'toggle',
            name = 'Short Message Style',
            desc = 'Check to print as Server: <ip:port>',
            get  = 'GetShort',
            set  = 'SetShort',
        },
    },
}


function VoiceServerPrint:OnInitialize()
  -- Code that you want to run when the addon is first loaded goes here.
   self:Print('|cFFFF0000Voice|cFFFFFFFFServer|rPrint|r loaded')
   LibStub("AceConfig-3.0"):RegisterOptionsTable("VoiceServerPrint", options, {"voiceserverprint", "vsp"})
   self.db = LibStub("AceDB-3.0"):New("VoiceServerPrintDB",{
		profile = {
			minimap = {
				hide = false,
			},
		},
	})
	
	-- defaults
	self.db.global.welcome = 'VoiceServerPrint V1.3b'
   
   -- LDB
   local LDB = LibStub("LibDataBroker-1.1"):NewDataObject("VoiceServerPrint", {
	type = "data source",
	text = "VoiceServerPrint",
	icon = "Interface\\Icons\\Spell_Nature_TimeStop",
	OnClick = function() VoiceServerPrint:ToogleGUI() end,
   })
   
   -- Minimap Icon
   local icon = LibStub("LibDBIcon-1.0")
   icon:Register("VoiceServerPrint", LDB, self.db.profile.minimap)
   
   -- Blizzard Options Panel   
   self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("VoiceServerPrint", "VoiceServerPrint")
   
   
   

end

function VoiceServerPrint:OnEnable()
    -- Called when the addon is enabled
end

function VoiceServerPrint:OnDisable()
    -- Called when the addon is disabled
end


function VoiceServerPrint:showInfo()
    -- Called when /vsp show
    
     self:Print('Server IP: '..self.db.global.IP)
      if self.db.global.Short 
    then 
      self:Print('Server: '..self.db.global.IP..':'..self.db.global.Port)
    else 
      self:Print('Server: '..self.db.global.IP)
      self:Print('Port: '..self.db.global.Port)
    end
end

function VoiceServerPrint:showBG()
    -- Called when /vsp show     
     self:PrintServer('BATTLEGROUND',0)
end

function VoiceServerPrint:showGroup()
    -- Called when /vsp show
     self:PrintServer('PARTY',0)
end

function VoiceServerPrint:showRaid()
    -- Called when /vsp show     
     self:PrintServer('RAID',0)
end

function VoiceServerPrint:showRaidWarning()
    -- Called when /vsp show     
     self:PrintServer('RAID_WARNING',0)
end
-- Get and Set Start
function VoiceServerPrint:GetIP(info)
    -- Returns the Saved IP
    return self.db.global.IP
end

function VoiceServerPrint:SetIP(info, input)
    -- Saves an IP
    self.db.global.IP = input
end

function VoiceServerPrint:GetPort(info)
    -- Returns the Saved Port
    return self.db.global.Port
end

function VoiceServerPrint:SetPort(info, input)
    -- Saves a Port
    self.db.global.Port = input
end

function VoiceServerPrint:GetPw(info)
    -- Returns the Saved Pw
    return self.db.global.Pw
end

function VoiceServerPrint:SetPw(info, input)
    -- Saves the Pw
    self.db.global.Pw = input
end

function VoiceServerPrint:ToogleGUI()
    -- shows or hides the gui
    --if self.frame:IsShown() then self.frame:Hide() else self.frame:Show() end
    self:BuildGUI()
end

function VoiceServerPrint:GetShort(info)
    -- Returns the Saved Port
    return self.db.global.Short
end

function VoiceServerPrint:SetShort(info, input)
    -- Saves a Port
    self.db.global.Short = input
end


function VoiceServerPrint:PrintServer(to,DBIndex)
    -- to = target chat channel
    -- DBIndex (Multiple Server PRE)
    
    -- determine whether player is promoted
    local offi = false
    if(to == 'RAID_WARNING') then
       if(IsRaidOfficer() or IsRaidLeader()) then
         offi = true
       end
       -- if not send to RAID
       if(not offi) then
         self:Print('You are not promoted send to raid instead!')
         to = 'RAID'
       end       
    end
    
    -- Send Chat Message
    SendChatMessage(self.db.global.welcome,to)
    if self.db.global.Short 
    then 
    SendChatMessage('Server: '..self.db.global.IP..':'..self.db.global.Port,to)
    else 
    SendChatMessage('Server: '..self.db.global.IP,to)
    SendChatMessage('Port: '..self.db.global.Port,to)
    end
    
    SendChatMessage('Password: '..self.db.global.Pw,to)
    
    
end
function VoiceServerPrint:BuildGUI()
    -- Builds the GUI


local   AceGUI = LibStub("AceGUI-3.0")
local frame = AceGUI:Create("Frame")
--local frame = CreateFrame("Frame","VSP",UIParent)
frame:SetTitle("VoiceServerPrint")
frame:SetStatusText("(c) by Isiss - Mal'Ganis | EU")
frame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) end)
frame:SetWidth(350)
frame:SetHeight(100)
frame:SetLayout("Flow")

local state = self.GetPartyState()



local button = AceGUI:Create("Button")
button:SetText("Self")
button:SetWidth(50)
button:SetCallback("OnClick", function() VoiceServerPrint:showInfo() end)
frame:AddChild(button)


local button = AceGUI:Create("Button")
button:SetText("Party")
button:SetWidth(75)
button:SetCallback("OnClick", function() VoiceServerPrint:showGroup() end)
if state == "solo" or state == "raid" or state == "heroic_raid" or state == "bg" then button:SetDisabled(true) end
frame:AddChild(button)

local button = AceGUI:Create("Button")
button:SetText("Raid")
button:SetWidth(75)
button:SetCallback("OnClick", function() VoiceServerPrint:showRaid() end)
if state == "solo" or state =="party" then button:SetDisabled(true) end
frame:AddChild(button)

local button = AceGUI:Create("Button")
button:SetText("RW")
button:SetWidth(50)
button:SetCallback("OnClick", function() VoiceServerPrint:showRaidWarning() end)
if state == "solo" or state =="party" then button:SetDisabled(true) end
frame:AddChild(button)

local button = AceGUI:Create("Button")
button:SetText("BG")
button:SetWidth(50)
button:SetCallback("OnClick", function() VoiceServerPrint:showBG() end)
if state == "bg" then else button:SetDisabled(true) end
frame:AddChild(button)


end

function VoiceServerPrint:GetPartyState()
		local _, instance_type = IsInInstance()

		if instance_type == "arena" then
			return "arena"
		end

		if instance_type == "pvp" then
			return "bg"
		end

		if GetNumRaidMembers() > 0 then
			if instance_type == "none" and GetZonePVPInfo() == "combat" then
				return "bg"
			end
			local raid_difficulty = GetRaidDifficulty()
			if raid_difficulty == 2 or raid_difficulty == 4 then
				return "heroic_raid"
			else
				return "raid"
			end
		end

		if GetNumPartyMembers() > 0 then
			return "party"
		end

		return "solo"
	end